<?php

/**
 * Plugin oEmbed
 * Licence GPL3
 *
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

function oembed_input_posttraite_twitter_dist($data) {

	$data['html'] = trim(preg_replace(',<script[^>]*></script>,i', '', $data['html']));
	if (!function_exists('recuperer_url')) {
		include_spip('inc/distant');
	}

	$url = $data['url'];
	if (preg_match(',status/(\d+)$,', $url, $m)) {
		$id = $m[1];
		$url_syndication = "https://cdn.syndication.twimg.com/tweet?id={$id}";
		if (
			$res = recuperer_url($url_syndication, ['taille_max' => 16384])
			and $json = json_decode($res['page'], true, 512, JSON_THROW_ON_ERROR)
		) {
			$author_thumbnail = $json['user']['profile_image_url_https'] ?? '';
			$lang = $json['lang'] ?? $GLOBALS['spip_lang'];
			$has_image = false;
			$enclosure = $enclosure_type = '';
			if (!empty($json['photos'])) {
				foreach ($json['photos'] as $photo) {
					if ($src = $photo['url'] ?? '') {
						$width = $photo['width'] ?? '';
						$height = $photo['height'] ?? '';
						if ($enclosure = copie_locale($src)) {
							$enclosure = url_absolue(_DIR_RACINE . $enclosure);
							$info = spip_getimagesize($enclosure);
							if (isset($info['mime'])) {
								$enclosure_type = $info['mime'];
							}
							else {
								$enclosure_type = image_type_to_mime_type($info[2]);
							}
							$has_image = true;
							break;
						}
					}
				}
			}

			if ($has_image and $enclosure) {
				//$src = str_replace(':large', ':small', $src);
				$data['html'] = "<img src='$enclosure' class='thumbnail p no-adapt-img' />" . $data['html'];
			}

			if ($content = $json['text'] ?? '') {
				$content = propre($content);
			}
			if ($published = $json['created_at'] ?? '') {
				$published = strtotime($published);
			}

			if ($content and $author_thumbnail and $published) {
				include_spip('oembed/input/posttraite_mastodon');
				$need_emoji = false;
				$screen_name = emojify($data['author_name'], $need_emoji);
				$content = emojify($content, $need_emoji);
				$contexte = [
					'url' => $data['oembed_url_source'],
					'width' => max($data['width'], 600),
					'height' => $data['height'],
					'author_screen_name' => $screen_name,
					'author_url' => $data['author_url'],
					'author_name' => '@' . ltrim(basename($data['author_url']), '@') . '@twitter.com',

					// A renseigner
					'author_thumbnail' => $author_thumbnail,
					'author_thumbnail_width' => '',
					'author_thumbnail_height' => '',
					'content' => $content,
					'published' => date('Y-m-d H:i:s', $published),
					'enclosure' => $enclosure,
					'enclosure_type' => $enclosure_type,
				];
				$contexte['need_emoji'] = $need_emoji;
				$data['html'] = recuperer_fond('modeles/toot', $contexte);
			}
		}
	}

	return $data;
}
